<?php

namespace Drupal\drd_pi;

use Drupal\Core\Config\Entity\ConfigEntityInterface;

/**
 * Provides an interface for defining Account entities.
 */
interface DrdPiAccountInterface extends ConfigEntityInterface {

  /**
   * @return mixed
   */
  public static function getConfigName();

  /**
   * @return string
   */
  public function getPlatformName();

  /**
   * @return $this
   */
  public function sync();

  /**
   * @return DrdPiHost[]
   */
  public function getPlatformHosts();

  /**
   * @param DrdPiHost $host
   *
   * @return DrdPiCore[]
   */
  public function getPlatformCores($host);

  /**
   * @param DrdPiCore $core
   *
   * @return DrdPiDomain[]
   */
  public function getPlatformDomains($core);

  /**
   * @param DrdPiDomain $domain
   * @param string $drushcmd
   *
   * @return bool
   */
  public function drush($domain, $drushcmd);

}
