<?php

namespace Drupal\drd_pi;

use Drupal\drd\Entity\Core;

/**
 * Provides platform based core.
 */
class DrdPiCore extends DrdPiEntity {

  /** @var DrdPiDomain[] */
  protected $domains = [];

  /** @var DrdPiHost */
  protected $host;

  /**
   * @inheritDoc
   */
  public function host() {
    return $this->host;
  }

  /**
   * @param DrdPiHost $host
   *
   * @return $this
   */
  public function setHost($host) {
    $this->host = $host;
    return $this;
  }

  /**
   * @param DrdPiDomain $domain
   *
   * @return $this
   */
  public function addDomain($domain) {
    $this->domains[$domain->id()] = $domain;
    return $this;
  }

  /**
   * @return DrdPiDomain[]
   */
  public function getDomains() {
    return $this->domains;
  }

  /**
   * @inheritDoc
   */
  public function create() {
    $this->entity = Core::create([
      'name' => $this->label,
      'host' => $this->host()->getDrdEntity()->id(),
      'drupal_root' => '',
      'pi_type' => $this->account->getEntityTypeId(),
      'pi_account' => $this->account->id(),
      'pi_id_host' => $this->host()->id(),
      'pi_id_core' => $this->id,
    ]);
    $this->entity->save();
    return $this;
  }

}
