<?php

namespace Drupal\drd_pi;

/**
 * Provides abstract class for platform based entities.
 */
abstract class DrdPiEntity implements DrdPiEntityInterface {

  /** @var DrdPiAccountInterface */
  protected $account;

  /** @var string */
  protected $label;

  /** @var string */
  protected $id;

  /** @var \Drupal\drd\Entity\BaseInterface */
  protected $entity;

  public function __construct($account, $label, $id) {
    $this->account = $account;
    $this->label = $label;
    $this->id = $id;
  }

  /**
   * @inheritDoc
   */
  public function id() {
    return $this->id;
  }

  /**
   * @inheritDoc
   */
  public function label() {
    return $this->label;
  }

  /**
   * @inheritDoc
   */
  public function setDrdEntity($entity) {
    $this->entity = $entity;
    return $this;
  }

  /**
   * @inheritDoc
   */
  public function getDrdEntity() {
    return $this->entity;
  }

  /**
   * @inheritDoc
   */
  public function hasDrdEntity() {
    return !empty($this->entity);
  }

}
