<?php

namespace Drupal\drd\Agent\Action\V6;

use Drupal\drd\Agent\Remote\V6\SecurityReview;

/**
 * Provides a 'Info' code.
 */
class Info extends Base {
  /**
   * @inheritDoc
   */
  public function execute() {
    // Initial set of information.
    $result = array(
      'root' => DRUPAL_ROOT,
      'version' => VERSION,
      'name' => variable_get('site_name', ''),
      'globals' => array(),
      'settings' => array(),
      'review' => SecurityReview::collect(),
    );

    // Load .install files.
    include_once DRUPAL_ROOT . '/includes/install.inc';
    drupal_load_updates();
    // Check run-time requirements and status information.
    $result['requirements'] = module_invoke_all('requirements', 'runtime');

    $vars = $GLOBALS;
    $result['variables'] = $vars['conf'];
    unset($vars['conf']);
    $result['globals'] = $vars;

    return $result;
  }

}
