<?php

namespace Drupal\drd\Agent\Action\V8;

use Drupal\block\BlockListBuilder;

/**
 * Provides a 'Blocks' code.
 */
class Blocks extends Base {

  private function listBlocks() {
    $block_list = array();

    $blb = BlockListBuilder::createInstance(\Drupal::getContainer(), \Drupal::entityTypeManager()->getDefinition('block'));
    /** @var \Drupal\block\BlockInterface[] $blocks */
    $blocks = $blb->load();
    foreach ($blocks as $id => $block) {
      $definition = $block->getPlugin()->getPluginDefinition();
      $block_list[$definition['provider']][$id] = $block->label();
    }

    return $block_list;
  }

  private function renderBlock($module, $delta) {
    $blb = BlockListBuilder::createInstance(\Drupal::getContainer(), \Drupal::entityTypeManager()->getDefinition('block'));
    /** @var \Drupal\block\BlockInterface[] $blocks */
    $blocks = $blb->load();
    if (isset($blocks[$delta])) {
      $block = $blocks[$delta];
      $build = $block->getPlugin()->build();
      return \Drupal::service('renderer')->renderPlain($build);
    }
    return array();
  }

  /**
   * @inheritDoc
   */
  public function execute() {
    if (!\Drupal::moduleHandler()->moduleExists('block')) {
      return array();
    }
    $args = $this->getArguments();
    if (!empty($args['module']) && !empty($args['delta'])) {
      return array(
        'data' => $this->renderBlock($args['module'], $args['delta']),
      );
    }
    return $this->listBlocks();
  }

}
