<?php

namespace Drupal\drd\Agent\Action\V8;

/**
 * Provides a 'Projects' code.
 */
class Projects extends Base {
  /**
   * @inheritDoc
   */
  public function execute() {
    $projects = [];

    // Core
    $extension = [
      'status' => 1,
      'info' => [
        'core' => '8.x',
        'version' => \Drupal::VERSION,
        'project' => 'drupal',
        'hidden' => FALSE,
      ],
    ];
    $this->buildProjectInfo($projects, 'core', 'drupal', (object) $extension);

    // Modules
    foreach (system_rebuild_module_data() as $name => $extension) {
      $this->buildProjectInfo($projects, 'module', $name, $extension);
    }

    // Themes
    foreach (\Drupal::getContainer()->get('theme_handler')->rebuildThemeData() as $name => $extension) {
      $this->buildProjectInfo($projects, 'theme', $name, $extension);
    }

    return $projects;
  }

  private function buildProjectInfo(&$projects, $type, $name, $extension) {
    $projects[] = [
      'name' => $name,
      'type' => $type,
      'status' => $extension->status,
      'info' => $extension->info,
    ];
  }

}
