<?php

namespace Drupal\drd\Agent\Auth\V8;

/**
 * Base class for Remote DRD Auth Methods for Drupal 8.
 */
abstract class Base extends \Drupal\drd\Agent\Auth\Base {
  /**
   * @inheritDoc
   */
  final public function validateUUID($uuid) {
    $config = \Drupal::configFactory()->get('drd_agent.settings');
    $authorised = $config->get('authorised');
    if (empty($authorised[$uuid])) {
      return FALSE;
    }
    $this->stored_settings = (array) $authorised[$uuid]['authsetting'];
    return TRUE;
  }

}
