<?php

namespace Drupal\drd\Command;

use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;

/**
 * Class Blocks.
 *
 * @package Drupal\drd
 */
class Blocks extends BaseDomain {

  public function __construct() {
    parent::__construct();
    $this->action_key = 'drd_action_blocks';
  }

  /**
   * {@inheritdoc}
   */
  protected function configure() {
    parent::configure();
    $this
      ->setName('drd:blocks')
      ->setDescription($this->trans('commands.drd.action.blocks.description'))
      ->addOption(
        'module',
        NULL,
        InputOption::VALUE_OPTIONAL,
        $this->trans('commands.drd.action.blocks.arguments.module')
      )
      ->addOption(
        'delta',
        NULL,
        InputOption::VALUE_OPTIONAL,
        $this->trans('commands.drd.action.blocks.arguments.delta')
      );
  }

  /**
   * @inheritDoc
   */
  protected function setActionArguments($action, InputInterface $input) {
    parent::setActionArguments($action, $input);
    if ($module = $input->getOption('module')) {
      $action->setActionArgument('module', $module);
    }
    if ($delta = $input->getOption('delta')) {
      $action->setActionArgument('delta', $delta);
    }
  }

}
