<?php

namespace Drupal\drd\Command;

use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;

/**
 * Class Ping.
 *
 * @package Drupal\drd
 */
class Ping extends BaseDomain {

  public function __construct() {
    parent::__construct();
    $this->action_key = 'drd_action_ping';
  }

  /**
   * {@inheritdoc}
   */
  protected function configure() {
    parent::configure();
    $this
      ->setName('drd:ping')
      ->setDescription($this->trans('commands.drd.action.ping.description'))
      ->addOption(
        'save',
        NULL,
        InputOption::VALUE_OPTIONAL,
        $this->trans('commands.drd.action.ping.arguments.save')
      );
  }

  /**
   * @inheritDoc
   */
  protected function setActionArguments($action, InputInterface $input) {
    parent::setActionArguments($action, $input);
    if ($save = $input->getOption('save')) {
      $action->setActionArgument('save', TRUE);
    }
    else {
      $action->setActionArgument('save', FALSE);
    }
  }

}
