<?php

namespace Drupal\drd\Command;

use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;

/**
 * Class ProjectsUpdate.
 *
 * @package Drupal\drd
 */
class ProjectsUpdate extends BaseCore {

  public function __construct() {
    parent::__construct();
    $this->action_key = 'drd_action_projects_update';
  }

  /**
   * {@inheritdoc}
   */
  protected function configure() {
    parent::configure();
    $this
      ->setName('drd:projects:update')
      ->setDescription($this->trans('commands.drd.action.projects.update.description'))
      ->addOption(
        'dry-run',
        NULL,
        InputOption::VALUE_NONE,
        $this->trans('commands.drd.action.projects.update.arguments.dryrun')
      )
      ->addOption(
        'show-log',
        NULL,
        InputOption::VALUE_NONE,
        $this->trans('commands.drd.action.projects.update.arguments.showlog')
      );
  }

  /**
   * @inheritDoc
   */
  protected function setActionArguments($action, InputInterface $input) {
    parent::setActionArguments($action, $input);
    $dry = $input->getOption('dry-run');
    if (isset($dry)) {
      $action->setActionArgument('dry-run', $dry);
    }
    $showlog = $input->getOption('show-log');
    if (isset($showlog)) {
      $action->setActionArgument('show-log', $showlog);
    }
  }

}
