<?php

namespace Drupal\drd\Command;

use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;

/**
 * Class ProjectsUpdateLog.
 *
 * @package Drupal\drd
 */
class ProjectsUpdateLog extends BaseCore {

  public function __construct() {
    parent::__construct();
    $this->action_key = 'drd_action_projects_update_log';
  }

  /**
   * {@inheritdoc}
   */
  protected function configure() {
    parent::configure();
    $this
      ->setName('drd:projects:update:log')
      ->setDescription($this->trans('commands.drd.action.projects.update.log.description'))
      ->addOption(
        'id',
        NULL,
        InputOption::VALUE_NONE,
        $this->trans('commands.drd.action.projects.update.log.arguments.id')
      )
      ->addOption(
        'list',
        NULL,
        InputOption::VALUE_NONE,
        $this->trans('commands.drd.action.projects.update.log.arguments.list')
      );
  }

  /**
   * @inheritDoc
   */
  protected function setActionArguments($action, InputInterface $input) {
    parent::setActionArguments($action, $input);
    $id = $input->getOption('id');
    if (isset($id)) {
      $action->setActionArgument('id', $id);
    }
    $list = $input->getOption('list');
    if (isset($list)) {
      $action->setActionArgument('list', $list);
    }
  }

}
