<?php

namespace Drupal\drd\Crypt;

use Drupal\Core\Form\FormStateInterface;

/**
 * Provides an interface for encryption.
 *
 * @ingroup drd
 */
interface BaseInterface {

  /**
   * @param string $method
   * @param array $settings
   * @return BaseMethodInterface
   */
  public static function getInstance($method, $settings);

  /**
   * @var bool $instances
   * @return array
   */
  public static function getMethods($instances = FALSE);

  /**
   * @param array|null $remote
   * @return int
   */
  public static function countAvailableMethods($remote = NULL);

  /**
   * A form API container with all the settings for DRD authentication.
   *
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   * @return array
   */
  public static function cryptForm(array $form, FormStateInterface $form_state);

  /**
   * Callback to extract all crypt settings from the submitted form.
   *
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   * @return array
   */
  public static function cryptFormValues(FormStateInterface $form_state);

}
