<?php

namespace Drupal\drd\Entity;

/**
 * Provides an interface for defining Host entities.
 *
 * @ingroup drd
 */
interface HostInterface extends BaseInterface {

  /**
   * @return string
   */
  public function getDrush();

  /**
   * @return string
   */
  public function getDrupalConsole();

  /**
   * @param array $properties
   * @return \Drupal\drd\Entity\CoreInterface[]
   */
  public function getCores($properties = []);

  /**
   * @param array $properties
   * @return \Drupal\drd\Entity\DomainInterface[]
   */
  public function getDomains($properties = []);

  /**
   * @return bool
   */
  public function supportsSsh();

  /**
   * @return array
   */
  public function getSshSettings();

  /**
   * @param bool $refresh
   *
   * @return string
   */
  public function getIpv4($refresh = TRUE);

  /**
   * Determine IP addresses of all associated domains and store them with the
   * host.
   */
  public function updateIpAddresses();

  /**
   * @param string $name
   * @return $this
   */
  public static function findOrCreateByHost($name);

}
