<?php

namespace Drupal\drd\Plugin\Action;

use Symfony\Component\Filesystem\Filesystem;

/**
 * Provides a 'Download' action.
 *
 * @Action(
 *  id = "drd_action_download",
 *  label = @Translation("Download a file"),
 *  type = "drd_domain",
 * )
 */
class Download extends BaseEntityRemote {

  /**
   * @inheritDoc
   */
  public function executeAction($domain) {
    $response = parent::executeAction($domain);
    if ($response) {
      if ($this->responseHeaders['X-DRD-Encrypted'][0]) {
        $fs = new Filesystem();
        $newfile = $this->arguments['destination'] . '.openssl';
        if ($fs->exists($newfile)) {
          $fs->remove($newfile);
        }
        $fs->rename($this->arguments['destination'], $newfile);
        $this->crypt->decryptFile($newfile);
      }
    }
    return $response;
  }

  /**
   * @inheritDoc
   */
  protected function setRequestOptions($request) {
    $request->setOption('sink', $this->arguments['destination']);
  }

  /**
   * @inheritDoc
   */
  protected function processResponse() {
    return FALSE;
  }

}
