<?php

namespace Drupal\drd\Plugin\Action;

use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a 'Php' action.
 *
 * @Action(
 *  id = "drd_action_php",
 *  label = @Translation("Execute PHP"),
 *  type = "drd_domain",
 * )
 */
class Php extends BaseEntityRemote implements BaseConfigurableInterface {

  public function __construct(array $configuration, $plugin_id, $plugin_definition) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
    $this->arguments['php'] = '';
  }

  /**
   * @inheritDoc
   */
  protected function getFollowUpAction() {
    return 'drd_action_info';
  }

  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $form['drd_action_php'] = array(
      '#type' => 'textarea',
      '#title' => t('PHP Code'),
      '#default_value' => '',
    );
    return $form;
  }

  public function validateConfigurationForm(array &$form, FormStateInterface $form_state) {}

  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    $this->arguments['php'] = $form_state->getValue('drd_action_php');
  }

}
