<?php

namespace Drupal\drd\Plugin\Action;

/**
 * Provides a 'Ping' action.
 *
 * @Action(
 *  id = "drd_action_ping",
 *  label = @Translation("Ping"),
 *  type = "drd_domain",
 * )
 */
class Ping extends BaseEntityRemote {

  /**
   * @inheritDoc
   */
  public function restrictAccess() {
    return FALSE;
  }

  /**
   * @inheritdoc
   */
  public function executeAction($domain) {
    $response = parent::executeAction($domain);
    $result = ($response && $response['data'] == 'pong');
    if (!empty($response['data'])) {
      $this->setOutput($response['data']);
    }
    if ($result !== $domain->getLatestPingStatus(FALSE)) {
      $domain->cachePingResult($result);
    }

    $domain->set('installed', $result);
    if ($this->arguments['save']) {
      $domain->save();
    }
    return $result;
  }

}
