<?php

namespace Drupal\drd\Plugin\Block;

use Drupal\Core\StringTranslation\TranslatableMarkup;

abstract class WidgetBase extends Base {

  /**
   * {@inheritdoc}
   */
  public function build() {
    $build = [];
    $build['drd_widget_title']['#markup'] = '<h2>' . $this->title() . '</h2>';
    $content = $this->message();
    if ($content instanceof TranslatableMarkup || is_string($content)) {
      $build['drd_widget']['#markup'] = $content;
    }
    else {
      $build['drd_widget'] = $content;
    }
    return $build;
  }

  abstract protected function title();
  abstract protected function message();

}
