<?php

namespace Drupal\drd\Plugin\Update\Deploy;

use Drupal\drd\Plugin\Update\Base as UpdateBase;
use Drupal\drd\Update\PluginDeployInterface;

/**
 * Abstract DRD Update plugin to implement general deploy functionality.
 */
abstract class Base extends UpdateBase implements PluginDeployInterface {

  protected $succeeded = FALSE;

  /**
   * @inheritDoc
   */
  public function dryRun($storage) {
    $storage->log('Nothing to do, dry run.');
    $this->succeeded = TRUE;
    return $this;
  }

  /**
   * @inheritDoc
   */
  final public function hasSucceeded() {
    return $this->succeeded;
  }

}
