<?php

namespace Drupal\drd\Plugin\Update\Deploy;

use Drupal\drd\Plugin\Update\RsyncTrait;

/**
 * Provides a Rsync deploy update plugin.
 *
 * @Update(
 *  id = "rsync",
 *  admin_label = @Translation("RSync to Live Site"),
 * )
 */
class Rsync extends Base {

  use RsyncTrait;

  /**
   * @inheritDoc
   */
  public function deploy($storage) {
    $this->sync($storage, FALSE);
    $this->succeeded = TRUE;
    return $this;
  }

  /**
   * @inheritDoc
   */
  public function dryRun($storage) {
    $this->sync($storage, FALSE, TRUE);
    $this->succeeded = TRUE;
    return $this;
  }

}
