<?php

namespace Drupal\drd;

use Drupal\Core\Form\FormStateInterface;

/**
 * Interface RemoteActionsInterface.
 *
 * @package Drupal\drd
 */
interface RemoteActionsInterface {

  const MODE_HOST = 'drd_host';
  const MODE_CORE = 'drd_core';
  const MODE_DOMAIN = 'drd_domain';

  /**
   * @param string $mode
   * @return RemoteActionsInterface
   */
  public function setMode($mode);

  /**
   * @return \Drupal\system\ActionConfigEntityInterface
   */
  public function getSelectedAction();

  /**
   * @return int
   */
  public function getExecutedCount();

  /**
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   * @param array $options
   */
  public function buildForm(&$form, FormStateInterface $form_state, $options = []);

  /**
   * @param $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   * @return mixed
   */
  public function validateForm(&$form, FormStateInterface $form_state);

  /**
   * @param \Drupal\drd\Entity\BaseInterface|\Drupal\drd\Entity\BaseInterface[] $entities
   * @return RemoteActionsInterface
   */
  public function setSelectedEntities($entities);

  /**
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   */
  public function submitForm(&$form, FormStateInterface $form_state);

}
