<?php

namespace Drupal\drd;

/**
 * Class Ssh.
 *
 * @package Drupal\drd
 */
abstract class Ssh implements SshInterface {

  protected $connection;

  protected $host;
  protected $port;
  protected $mode;
  protected $username;
  protected $password;
  protected $pubKeyFile;
  protected $privKeyFile;
  protected $passphrase;

  /**
   * @var string
   */
  protected $output = '';

  /**
   * @var string
   */
  protected $error = '';

  public function __construct($host, $port, $mode, $username, $password, $pubKeyFile, $privKeyFile, $passphrase) {
    $this->host = $host;
    $this->port = $port;
    $this->mode = $mode;
    $this->username = $username;
    $this->password = $password;
    $this->pubKeyFile = $pubKeyFile;
    $this->privKeyFile = $privKeyFile;
    $this->passphrase = $passphrase;
  }

  /**
   * @inheritDoc
   */
  function getOutput() {
    return $this->output;
  }

  /**
   * @inheritDoc
   */
  function getError() {
    return $this->error;
  }

}
