<?php

namespace Drupal\drd\Update;

/**
 * Provides an interface for the discovery and instantiation of DRD Update
 * plugins for storage, build and process steps.
 */
interface ManagerStorageInterface extends ManagerInterface {

  /**
   * @param array $settings
   * @return PluginStorageInterface
   * @throws \Exception
   */
  public function executableInstance($settings);

  /**
   * A form API container with all the settings for DRD Update plugins.
   *
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   * @param array $settings
   */
  public function buildGlobalForm(&$form, $form_state, $settings);

  /**
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   */
  public function validateGlobalForm(&$form, $form_state);

  /**
   * @param array $form
   * @param \Drupal\Core\Form\FormStateInterface $form_state
   * @return array
   */
  public function globalFormValues($form, $form_state);

}
