<?php

namespace Drupal\drd\Update;

use Drupal\Component\Plugin\ConfigurablePluginInterface;
use Drupal\Core\Plugin\PluginFormInterface;

/**
 * Defines the required interface for all DRD Update plugins.
 */
interface PluginInterface extends ConfigurablePluginInterface, PluginFormInterface {

  /**
   * @param string $parent
   * @param array $condition
   *
   * @return $this
   */
  public function setConfigFormContext($parent, $condition);

  /**
   * @return array
   */
  public function scriptHooks();

  /**
   * @param PluginStorageInterface $storage
   * @param string $hook
   *
   * @return $this
   */
  public function executeScript($storage, $hook);

  /**
   * Called before saving the working directory back to the source in reverse
   * order of all the used plugins.
   *
   * @param PluginStorageInterface $storage
   *
   * @return $this
   */
  public function cleanup($storage);

}
